Query links for subtasks on issue page

2018-03-30 12:12 - Sebastian Paluch

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 4.2.0   

Resolution: Fixed   

Description

The header on issue page "Subtasks" list issues, in some way, with some defaults columns. It would be very helpful if the section

header could be clickable link to issue queries showing those issues:

- Subtasks should link to issue query with filter parent "contains" the issue number

It would be good to have same thing for "Related issues" but there seems to be no filter allowing to show all types of relations.

Related issues:

Related to Redmine - Feature #35559: Query links for related issues on issue ... Closed

Associated revisions

Revision 20321 - 2020-11-10 04:41 - Go MAEDA

Query links for subtasks on issue page (#28471).

Patch by Bernhard Rohloff.

Revision 20718 - 2021-01-18 08:11 - Go MAEDA

Some fixes for r20321:

Include only visible issues in subtasks stats

Get subtasks using only one query

Show all subtasks count as badge

Add tests

Patch by Marius BALTEANU.

History

#1 - 2018-03-31 07:00 - Go MAEDA

It is a nice idea. Many people have requested to add more columns to the list of subtasks and related issues. It will be the solution to the request if we

can move to the issues list with one click.

#2 - 2018-06-21 07:36 - Ewan Makepeace

+1 - I would dearly love this.

#3 - 2019-08-02 09:19 - Ewan Makepeace

Specofically whjen I am in the Roadmap I can jump from the simple list of issues in a target verson such as:

http://www.redmine.org/versions/127

To a query on either All Issues:

http://www.redmine.org/projects/redmine/issues?fixed_version_id=127&set_filter=1&status_id=%2A

Or just Open or Closed. This is hugely useful as I can then sort, group and filter to get the answers I need.

However when subtasks are grouped under a parent task there is no shortcut. I can search all issues by Parent (which is often enough) but:

1. I would like to see this as a shortcut on the issue page (just above subtasks)

2. I often have nested groups of tasks and so really want to see all subtasks and not just those that are a direct child of the current task.
SELECT i.* 

FROM issues i

JOIN issues p 

    ON p.root_id = i.root_id 

    AND p.lft<i.lft 

    AND p.rgt>i.rgt

WHERE p.id = @PARENT_ID;

#4 - 2019-09-05 06:41 - Bernhard Rohloff

- File query_links_for_subtasks.diff added

This patch implements Ewan's proposal. It's quite convenient to filter subtasks this way. Good idea!

#5 - 2019-09-05 07:01 - Bernhard Rohloff

- File subtask_query_links.png added

here's how it looks now...

 subtask_query_links.png 

#6 - 2019-11-28 00:40 - Anonymous

+1, it's a green light from me ;-)

#7 - 2019-12-15 09:21 - Go MAEDA

- Target version set to Candidate for next major release

#8 - 2020-04-25 11:23 - Marius BĂLTEANU

- File subtasks.png added

I reworked a little bit the patch proposed by Bernhard:

 subtasks.png 

What do you think?

#9 - 2020-04-26 11:27 - Bernhard Rohloff

IMHO, it looks like a nice improvement. :-)

#10 - 2020-10-27 11:22 - Bernhard Rohloff

- File query_links_for_subtasks_marius_flavor.diff added

I've added a new patch with Marius' improvements. In my opinion it would be a nice improvement to ship with 4.2.0. What do you think?

#11 - 2020-11-05 06:16 - Go MAEDA

- File clipboard-202011051408-i3dmb.png added

- File clipboard-202011051409-nusza.png added

Bernhard Rohloff wrote:

I've added a new patch with Marius' improvements. In my opinion it would be a nice improvement to ship with 4.2.0. What do you think?

 Thank you for updating the patch. I think the feature is nice but the number of open/closed issues and filtered issues don't not match if subtasks has

its subtasks (grand child).

See the example below. The issue has a subtask (#15 "child"). And the subtask has a subtask (#16 "grand child"). Redmine says that there are 2

open issues.

 clipboard-202011051408-i3dmb.png 

However, after you click the "2 open" link, the issues list displays only 1 issue.
clipboard-202011051409-nusza.png 

#12 - 2020-11-05 09:21 - Go MAEDA
Maybe #28471#note-11 can be fixed by using "contains" operator instead of "is" operator.

#13 - 2020-11-05 15:25 - Bernhard Rohloff

- File query_links_for_subtasks_marius_flavor_V2.diff added

Thank you Maeda san for testing my patch. Here's a slightly better version of my previous patch including your suggestion. It's indeed better to do it

this way. :-)

#14 - 2020-11-07 05:15 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0

Bernhard Rohloff wrote:

Thank you Maeda san for testing my patch. Here's a slightly better version of my previous patch including your suggestion. It's indeed better to

do it this way. :-)

 Thank you for updating the patch. The patch now looks good. Setting the target to 4.2.0.

#15 - 2020-11-10 04:42 - Go MAEDA

- Subject changed from Make "Subtasks" section headers a links to issue query to Query links for subtasks on issue page

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for your contribution.

#16 - 2020-11-10 10:06 - Marius BĂLTEANU

- Status changed from Closed to Reopened

We should add some functional tests.

#17 - 2020-11-11 08:51 - Bernhard Rohloff

Here's some test code. Since I'm not very used to rails testing, I'm not sure if it's sufficient enough.

Index: test/functional/issues_controller_test.rb

===================================================================

--- test/functional/issues_controller_test.rb   (Revision 20333)

+++ test/functional/issues_controller_test.rb   (Arbeitskopie)

@@ -2299,6 +2299,49 @@

     end

   end

+  def test_show_should_show_subtasks_links_to_queries

+    child = Issue.

+      create!(

+        :project_id => 1, :author_id => 1, :tracker_id => 1,

+        :parent_issue_id => 1, :subject => 'Child issue'

+      )

+    get(:show, :params => {:id => 1})

+    assert_response :success

+    assert_select 'div#issue_tree' do

+      assert_select 'p' do

+        assert_select 'a', :text => '1 issue'

+        assert_select 'a', :text => '1 open'

+      end

+    end

+    Issue.

+      create!(

+        :project_id => 1, :author_id => 1, :tracker_id => 1,

+        :parent_issue_id => child.id, :subject => 'Child of child'

+    )

+    get(:show, :params => {:id => 1})

+    assert_response :success

+    assert_select 'div#issue_tree' do

+      assert_select 'p' do
+        assert_select 'a', :text => '2 issues'

+        assert_select 'a', :text => '2 open'

+      end

+    end

+    Issue.

+      create!(

+        :project_id => 1, :author_id => 1, :tracker_id => 1,

+        :parent_issue_id => 1, :status_id => 5, :subject => 'Closed child issue'

+    )

+    get(:show, :params => {:id => 1})

+    assert_response :success

+    assert_select 'div#issue_tree' do

+      assert_select 'p' do

+        assert_select 'a', :text => '3 issues'

+        assert_select 'a', :text => '2 open'

+        assert_select 'a', :text => '1 closed'

+      end

+    end

+  end

+

   def test_show_should_list_parents

     issue = Issue.

               create!(

#18 - 2020-12-05 22:39 - Marius BĂLTEANU

- File subtasks.png added

- File 0001-Include-only-visible-issues-in-subtasks-stats.patch added

Thanks Bernhard for the tests.

Reviewing them, I found out that the current implementation has two issues:

issue visibility is not checked

there are quite many queries to get the subtasks

I took the liberty to rewrite a little bit the current implementation in order to:

fix the issue visibility

get subtasks using one query by grouping them

move the entire logic from view to helper

change the layout to show the subtasks count as badge

finalise the tests

 subtasks_v2.png 

#19 - 2020-12-06 01:36 - Marius BĂLTEANU

- Assignee changed from Go MAEDA to Marius BĂLTEANU

Some tests fail on Postgres and Sql server.

#20 - 2020-12-06 23:00 - Marius BĂLTEANU

- File deleted (subtasks.png)

#21 - 2020-12-06 23:00 - Marius BĂLTEANU

- File deleted (0001-Include-only-visible-issues-in-subtasks-stats.patch)

#22 - 2020-12-06 23:08 - Marius BĂLTEANU

- File 0001-Include-only-visible-issues-in-subtasks-stats.patch added

- Assignee deleted (Marius BĂLTEANU)

I've fixed the issue by casting the values returned from the database to boolean. Now the tests pass on all three database types: 

https://gitlab.com/redmine-org/redmine/-/pipelines/225982433

#23 - 2020-12-06 23:08 - Marius BĂLTEANU

- File subtasks_v2.png added
#24 - 2020-12-07 05:08 - Bernhard Rohloff

- Assignee set to Marius BĂLTEANU

Thank you Marius for reviewing and improving my work. I really like the badge style.

BTW my implementation was shamelessly copied from the versions/_overview partial found in the roadmap. So we may have room for improvements

over there, too.

#25 - 2020-12-07 05:09 - Bernhard Rohloff

- Assignee deleted (Marius BĂLTEANU)

#26 - 2021-01-07 16:36 - Go MAEDA

Marius BALTEANU wrote:

I've fixed the issue by casting the values returned from the database to boolean. Now the tests pass on all three database types: 

https://gitlab.com/redmine-org/redmine/-/pipelines/225982433

 Thank you for posting the 0001-Include-only-visible-issues-in-subtasks-stats.patch but the test fails if you run it with Ruby 2.4.

$ ruby test/functional/issues_controller_test.rb 

Run options: --seed 49701

# Running:

......................F

Failure:

IssuesControllerTest#test_show_should_show_subtasks_stats [test/functional/issues_controller_test.rb:2354]:

Expected at least 1 element matching "span.open a[href="/issues?parent_id=~1&set_filter=true&status_id=o"]", f

ound 0..

Expected 0 to be >= 1.

bin/rails test test/functional/issues_controller_test.rb:2343

....................................S.........................................................................

.....................................................................S........................................

.............................................................................................................S

....................................F

Failure:

IssuesControllerTest#test_show_subtasks_stats_should_not_link_if_issue_has_zero_open_or_closed_subtasks [test/

functional/issues_controller_test.rb:2367]:

Expected at least 1 element matching "span.open a[href="/issues?parent_id=~1&set_filter=true&status_id=o"]", f

ound 0..

Expected 0 to be >= 1.

bin/rails test test/functional/issues_controller_test.rb:2361

..............................

 This is because issue_path method returns a different value depending on the version of Ruby.

# Ruby 2.4

(byebug) issues_path(parent_id: "~1", set_filter: true)

"/issues?parent_id=%7E1&set_filter=true" 

# Ruby 2.5 or later

(byebug) issues_path(parent_id: "~1", set_filter: true)

"/issues?parent_id=~1&set_filter=true" 

#27 - 2021-01-09 20:40 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

#28 - 2021-01-09 21:27 - Marius BĂLTEANU

- File 0002-Unescape-href-values-before-asserting.patch added

- Assignee changed from Marius BĂLTEANU to Go MAEDA

Can you try on Ruby 2.4 using the attached patch, please? It should pass now. If still doesn't, I will create a local environment with 2.4.
#29 - 2021-01-10 01:33 - Go MAEDA

- Assignee changed from Go MAEDA to Marius BĂLTEANU

Marius BALTEANU wrote:

Can you try on Ruby 2.4 using the attached patch, please? It should pass now.

 Thank you, I confirmed that there is no test failure with 2.4.

#30 - 2021-01-14 14:42 - Go MAEDA

- Assignee changed from Marius BĂLTEANU to Go MAEDA

#31 - 2021-01-18 08:13 - Go MAEDA

- Status changed from Reopened to Closed

Committed 0001-Include-only-visible-issues-in-subtasks-stats.patch and 0002-Unescape-href-values-before-asserting.patch in r20718.

Thank you for providing the fixes and improvements.

#32 - 2021-08-23 14:54 - Go MAEDA

- Related to Feature #35559: Query links for related issues on issue page added
